#include <fcntl.h>
#include <limits.h>
#include <stdio.h>

#define BUF_SIZE 1024

void parm_dbg(int argc, char* argv[], char* envp[])
{
	int i;
	char** p;

	printf ("argc = %d\n", argc);
	for (i = 0; i < argc; i++)
	  printf ("argv[%d] = %s\n", i, argv[i]);
	for (p = envp, i = 0; *p; p++, i++)
	  printf ("envp[%d] = %s\n", i, *p);
}

int main(int argc, char* argv[], char* envp[])
{
	int fd;
	int i, ret, retw;
	char buf[BUF_SIZE];

	parm_dbg(argc, argv, envp);

	if (argc < 2){
		printf ("Usage: %s file ...\n", argv[0]);
		exit (1);
	}

	for (i = 1; i < argc; i++){
		fd = open(argv[i], O_RDONLY);
		if (fd < 0){
			perror(argv[i]);
			exit (1);
		}
#ifdef SENDFILE_ACCEL
		ret = sendfile(1, fd, NULL, INT_MAX);
		if (ret < 0 && ret != -EINVAL){
			perror("sendfile");
			exit (1);
		}
#endif
		while ((ret = read(fd, buf, sizeof buf)) > 0){
			while (ret){
				retw = write(1, buf, ret);
				if (retw < 0){
					perror("write");
					exit(1);
				}
				ret -= retw;
			}
		}
		if (ret < 0){
			perror("read");
			exit(1);
		}
		close(fd);
	}

	return 0;
}

/*
 *
 */
