#ifndef _ZX_UTMP_H_
#define _ZX_UTMP_H_

#include <sys/cdefs.h>
#include <sys/types.h>

#define INIT_PROCESS	5
#define LOGIN_PROCESS	6
#define USER_PROCESS	7
#define DEAD_PROCESS	8

#define UT_LINESIZE	32
#define UT_NAMESIZE	32
#define UT_HOSTSIZE	256

__BEGIN_DECLS

struct exit_status
  {
    short int e_termination;
    short int e_exit;
  };

struct utmp
  {
    short int ut_type;
    pid_t ut_pid;
    char ut_line[UT_LINESIZE];
    char ut_id[4];
    char ut_user[UT_NAMESIZE];
#define ut_name ut_user
    char ut_host[UT_HOSTSIZE];
    struct exit_status ut_exit;
    long ut_session;
    struct timeval ut_tv;
    int32_t ut_addr_v6[4];
    char pad[20];
  };

extern struct utmp *getutent __P ((void));
extern void setutent __P ((void));

extern __inline__ struct utmp *
getutent (void)
{
  return NULL;
}

__END_DECLS

#endif
