#include "dirent.h"
#include "fcntl.h"
#include "unistd.h"
#include "errno.h"

DIR *
opendir (const char *pathname)
{
  int fd;
  static DIR dir = { _fd: -1 };
  static int dir_init = 0;

  if (!dir_init)
    {
      dir._fd = -1;
      dir_init = 1;
    }

  if (dir._fd >= 0)
    {
      errno = EMFILE;
      return NULL;
    }

  if ((fd = open (pathname, O_RDONLY)) < 0)
    return NULL;

  dir._ptr = dir._end = dir._buf + sizeof (dir._buf);
  return &dir;
}
