#include "dirent.h"
#include "errno.h"

struct dirent *
readdir (DIR *dir)
{
  struct dirent *de;

  if (!dir || dir->_fd < 0)
    {
      errno = EBADF;
      return NULL;
    }

  if (dir->_ptr >= dir->_end)
    {
      int r = getdents (dir->_fd, (struct dirent *) dir->_buf,
			sizeof (dir->_buf));
      if (r <= 0)
	return NULL;
      dir->_ptr = dir->_buf;
      dir->_end = dir->_buf + r;
    }

  de = (struct dirent *) dir->_ptr;
  dir->_ptr += de->d_reclen;
  return de;
}
