#include "stdlib.h"

void *
bsearch (const void* key, const void* base, size_t nmemb,
	 size_t size, int (*compar)(const void*, const void*))
{
	unsigned long l, r, c;

	l = 0;
	r = nmemb;

	while ((c = (l+r) / 2) != l){
		if (compar (((char*)base)+size*c, key) <= 0)
			l = c;
		else
			r = c;
	}
	
	if (!compar(((char*)base)+size*c, key))
		return (void*)(((char*)base)+size*c);

	return NULL;
}


